UNIT Ugra;
{$G+}
INTERFACE

    TYPE  screentyp  = ARRAY[0..63999] OF byte;
          spriteType = RECORD
                         maske : pointer;
                         width,height   : Word;
                       END;

    VAR   screen   :^screentyp;
          spritez  : byte;
          sprite   : ARRAY[0..255] OF spriteType;
          palette  : ARRAY[0..770] OF byte;

    PROCEDURE gra_on;                                      {Initalisierung}
    PROCEDURE gra_off;                                     {Gibt belegten Speicher wieder frei u.a.}
    PROCEDURE pixel (x,y:Integer;B:Byte);                    {auf screen}
    PROCEDURE Load_scx (s:STRING;B:boolean);                 {64000 SCX auf $A000:0 ; B:palette}
    PROCEDURE Load_pal (s:STRING);                           {ld palette}
    PROCEDURE Set_pal;                                       {setzt palette}
    PROCEDURE SetPal(Col,R,G,B : Byte);
    PROCEDURE GetPal(Col : Byte; VAR R, G, B : Byte);
    PROCEDURE draw_all;                                      {Gibt Screen auf $a000:0 aus}
    PROCEDURE load_sprite (s:STRING);                        {ohne palette (.SCX) (reserviert Maske)}
    PROCEDURE blitsprite (x,y,SpriteNummer:Word);   {Malt auf screen eine Maske}
    PROCEDURE cls;                                           {clrscr}
    PROCEDURE WaitRetrace;                                   {Konstante Warteschleife}
    PROCEDURE Draw_Char( zeichen : char; x, y : integer; vg : byte );{Schreibt Zeichen}
    PROCEDURE Draw_String( x, y : integer; vg : byte; tstr : string );{Schreibt String}
    function Xkolision(kx,ky,bx,by:word;k_x,k_y,b_x,b_y:byte): boolean; {prft ob kolision in 2D}
    function Ykolision(kx,ky,bx,by:word;k_x,k_y,b_x,b_y:byte): boolean; {prft ob kolision in 2D}
    procedure blackP(x,y,xx,yy:word);
    function IntToStr(I: Longint): String;

IMPLEMENTATION

USES dos;

PROCEDURE Draw_Char( zeichen : char; x, y : integer; vg : byte );
TYPE ZDEF = ARRAY[0..255,0..7] OF byte;
     ZPTR = ^ZDEF;
VAR  regs : registers;
     ch    : char;
     i, k,
     Maske : byte;
CONST fptr : ZPTR = NIL;
BEGIN
  IF fptr = NIL THEN
    BEGIN
      Regs.AH := $11;
      Regs.AL := $30;
      Regs.BH := 3;
      intr( $10, Regs );
      fptr := ptr( Regs.ES, Regs.BP );
    END;
    FOR i := 0 TO 7 DO
      BEGIN
        Maske := fptr^[ord(zeichen),i];
        FOR k := 0 TO 7 DO
          BEGIN
            IF ( Maske AND 128 <> 0 ) THEN
              pixel( x+k, y+i, vg );
            Maske := Maske SHL 1;
          END;
      END
END;

PROCEDURE Draw_String( x, y : integer; vg : byte; tstr : string );
VAR i : integer;
BEGIN
  FOR i := 1 TO length( tstr ) DO
    BEGIN
      Draw_Char( tstr[i], x, y, vg );
      inc( x, 8 );
    END;
END;

PROCEDURE cls;ASSEMBLER;
   ASM
      les di,screen
      mov cx,16000
      xor di,di
      xor bx,bx
      mov al,bl
      mov ah,bl
      db $66; SHL ax,16
      mov al,bl
      mov ah,bl
      db $66; rep stosw
   END;

PROCEDURE GetPal(Col : Byte; VAR R, G, B : Byte);
BEGIN
   port[$3c7]:=col;
   r:=port[$3c9];
   g:=port[$3c9];
   b:=port[$3c9];
END;

PROCEDURE SetPal(Col,R,G,B : Byte); ASSEMBLER;
ASM
   mov    dx,3c8h
   mov    al,[col]
   out    dx,al
   inc    dx
   mov    al,[r]
   out    dx,al
   mov    al,[g]
   out    dx,al
   mov    al,[b]
   out    dx,al
END;

PROCEDURE WaitRetrace;
ASSEMBLER;
  ASM
    mov dx,$3da
  @1:
    IN al,dx
    test al,8
    jz @1
  @2:
    IN al,dx
    test al,8
    jnz @2
  END;

PROCEDURE pixel (x,y:Integer;B:Byte);ASSEMBLER;
ASM
   mov ax,y
   mov bx,ax
   SHL ax,8
   SHL bx,6
   add bx,ax
   add bx,x
   mov cl,b
   les di,screen
   mov [es:bx+di],cl
END;

PROCEDURE load_pal (s:STRING);
VAR f:FILE;
BEGIN
   assign (f,s);
   reset (f,1);
   blockread (f,palette,768);
   close (f);
END;

PROCEDURE set_pal;
VAR k:word;
BEGIN
   port[$3c8]:=0;
   FOR k:=0 TO 767 DO port[$3c9]:=palette[k];
END;

PROCEDURE Load_scx (s:STRING;B:boolean);
VAR f:FILE;
    k:word;
BEGIN
   assign (f,s);
   reset (f,1);
   seek (f,10);
   blockread (f,palette,768);
   port[$3c8]:=0;
   IF b THEN FOR k:=0 TO 767 DO port[$3c9]:=palette[k];
   blockread (f,mem[$A000:0],64000);
   close (f);
END;

PROCEDURE load_sprite (s:STRING);
VAR f:FILE;
BEGIN
   WITH sprite[spriteZ] DO
   BEGIN
     assign (f,s);
     reset (f,1);
     seek (f,4);
     blockread (f,width,2);
     blockread (f,height,2);
     seek (f,778);
     getmem (maske,width*height);
     blockread (f,maske^,width*height);
     close (f);
     inc (spritez);
   END;
END;

PROCEDURE blitsprite (x,y,SpriteNummer:Word);
VAR
  pc,ad   : Word;
  spritep : Pointer;
  w,h     : Integer;

BEGIN
  WITH Sprite[SpriteNummer] DO
  BEGIN
    w := width;
    h := height;
    spritep := maske;
  END;

ASM
   push ds
   les di,screen
   lds si,spritep
   mov ax,y

   mov dx,h
   cmp ax,199
   jg @ende
   mov cx,h
   neg cx
   inc cx
   cmp ax,cx
   jl @ende
   mov cx,200
   sub cx,h
   cmp ax,cx
   jl @ylowclip
   mov dx,200
   sub dx,ax
   jmp @endclipy
@ylowclip:
   cmp ax,0
   jnl @endclipy
   add dx,ax
   sal ax,5
   sub si,ax
   xor ax,ax
@endclipy:
   mov bx,ax
   SHL ax,8
   SHL bx,6
   add di,ax
   add di,bx
   mov ax,w
   mov pc,ax
   mov bx,x

   mov cx,w
   neg cx
   inc cx
   cmp bx,cx
   jl @ende
   cmp bx,319
   jg @ende
   mov cx,320
   sub cx,w
   cmp bx,cx
   jna @endxclip
   jng @xlowclip
   mov ax,320
   sub ax,bx
   mov pc,ax
   jmp @endxclip
@xlowclip:
   cmp bx,0
   jge @endxclip
   sub si,bx
   add pc,bx
   xor bx,bx
@endxclip:
   add di,bx
   mov ax,w
   sub ax,pc
   mov bx,ax
@yloop:
   mov cx,pc
@xloop:
   mov al,[si]
   inc si
   OR al,al
   jz @weiter
   mov [es:di],al
@weiter:
   inc di
   dec cx
   jnz @xloop
   add di,320
   sub di,w
   add si,bx
   add di,bx
   dec dx
   jnz @yloop
@ende:
   pop ds
END;
END;

PROCEDURE draw_all; ASSEMBLER;
   ASM
      push ds
      mov ax,$a000
      mov es,ax
      xor di,di
      lds si,screen
      mov cx,16000
      db $66; rep movsw
      pop ds
   END;

PROCEDURE gra_on;
BEGIN
  ASM
    mov ax,13h
    int 10h
  END;
  getmem (screen,64000);
  fillchar (screen^,64000,0);
  spritez:=0;
END;

PROCEDURE gra_off;
VAR k:byte;
BEGIN
  freemem (screen,64000);
  FOR k:=0 TO Spritez DO WITH Sprite[k] DO freemem(maske,width*height);
  ASM
    mov ax,3h
    int 10h
  END;
END;

function XKolision(kx,ky,bx,by:word;k_x,k_y,b_x,b_y:byte):boolean;
begin
 if (kx+k_x+1>bx ) and (kx<bx+b_x) and
    (ky+k_y-1>by) and (ky<by+b_y-1)
       then xkolision:=true
       else xkolision:=false
end;

function YKolision(kx,ky,bx,by:word;k_x,k_y,b_x,b_y:byte):boolean;
begin
 if (ky+k_y+1>by) and (ky<by+b_y) and
    (kx+k_x-1>bx) and (kx<bx+b_x-1)
       then ykolision:=true
       else ykolision:=false
end;

procedure blackp(x,y,xx,yy:word);
var ix,iy:word;
begin
 for ix:=x to xx do
  for iy:=y to yy do
   if (iy<=200) and (ix<=320) then pixel(ix,iy,0);
end;

function IntToStr(I: Longint): String;
var
 S: string[11];
begin
 Str(I, S);
 IntToStr := S;
end;

END.